"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSortKeyFieldNames = exports.getTable = exports.getKeySchema = void 0;
const assert = __importStar(require("assert"));
const graphql_transformer_common_1 = require("graphql-transformer-common");
const getKeySchema = (table, indexName) => {
    var _a, _b, _c;
    return ((_c = (_b = ((_a = table.globalSecondaryIndexes.find((gsi) => gsi.indexName === indexName)) !== null && _a !== void 0 ? _a : table.localSecondaryIndexes.find((gsi) => gsi.indexName === indexName))) === null || _b === void 0 ? void 0 : _b.keySchema) !== null && _c !== void 0 ? _c : table.keySchema);
};
exports.getKeySchema = getKeySchema;
const getTable = (ctx, object) => {
    const ddbDataSource = ctx.dataSources.get(object);
    const tableName = graphql_transformer_common_1.ModelResourceIDs.ModelTableResourceID(object.name.value);
    const table = ddbDataSource.ds.stack.node.findChild(tableName);
    assert.ok(table);
    return table;
};
exports.getTable = getTable;
const getSortKeyFieldNames = (type) => {
    const sortKeyFieldNames = [];
    type.fields.forEach(field => {
        field.directives.forEach(directive => {
            var _a, _b;
            if (directive.name.value === 'primaryKey') {
                const values = (_b = (_a = directive.arguments) === null || _a === void 0 ? void 0 : _a.find(arg => arg.name.value === 'sortKeyFields')) === null || _b === void 0 ? void 0 : _b.value;
                if (values) {
                    sortKeyFieldNames.push(...values.values.map(it => it.value));
                }
            }
        });
    });
    return sortKeyFieldNames;
};
exports.getSortKeyFieldNames = getSortKeyFieldNames;
//# sourceMappingURL=schema-utils.js.map